<?php

/**
 * @file
 * Handles the form submission of the customer survey form
 */


/**
 * Handles what to do with the submitted form depending on what stage has been
 * complated.
 *
 * @see sauce_form()
 * @see sauce_form_validate()
 *
 * @param type $form
 * @param type $form_state
 */
function sauce_form_submit($form, &$form_state) {
 // dsm($form_state['stage']);
  switch ($form_state['stage']) {
    case 'sauce_install':
      $form_state['multistep_values'][$form_state['stage']] = $form_state['values'];
      if ($form_state['triggering_element']['#value'] != 'Back') {
        sauce_install_submit($form, $form_state);
        $form_state['new_stage'] = sauce_move_to_next_stage($form, $form_state);
      }
      break;

    case 'sauce_configure':
      $form_state['multistep_values'][$form_state['stage']] = $form_state['values'];
      if ($form_state['triggering_element']['#value'] != 'Back') {
        sauce_configure_submit($form, $form_state);
        $form_state['complete'] = TRUE;
      }
      break;

    default:
      $form_state['multistep_values'][$form_state['stage']] = $form_state['values'];
      $form_state['new_stage'] = sauce_move_to_next_stage($form, $form_state);
      break;

  }

  if (isset($form_state['complete'])) drupal_goto('complete-page');

  if ($form_state['triggering_element']['#value'] == 'Back') {
    $form_state['new_stage'] = sauce_move_to_previous_stage($form, $form_state);
  }

  if (isset($form_state['multistep_values']['form_build_id'])) {
    $form_state['values']['form_build_id'] = $form_state['multistep_values']['form_build_id'];
  }
  $form_state['multistep_values']['form_build_id'] = $form_state['values']['form_build_id'];
  $form_state['stage'] = $form_state['new_stage'];
  $form_state['rebuild'] = TRUE;

}

function sauce_install_submit($form, &$form_state) {
  // dsm("installing");
  $download_id = $form_state['values']['sauce_installed_item_id'];
  // dsm($download_id);
  $result = xmlrpc('http://drupalsauce.technikh.com/xmlrpc.php', array(
      'sauce.process_download_request' => array($download_id),
  ));
  //dsm($result);
  $json_decoded = drupal_json_decode($result);
  // dsm($json_decoded);
  $sauce_config_markup = '';
  $module_list = array();
  $theme_list = array();
  //loop through each addon
  foreach($json_decoded as $nid => $node){
    $addon_title = $node['title'];
    $addon_type_id = $node['field_addon_type']['und'][0]['tid'];
    $addon_id = $node['field_addon_id']['und'][0]['value'];
    //$package_url = $node['field_addon_package_url']['und'][0]['url'];
    $package_url = (isset($node['field_addon_package_url']['und']) && is_array($node['field_addon_package_url']['und'])) ? $node['field_addon_package_url']['und'][0]['url'] : null;

    $addon_resources = (isset($node['field_addon_resources']['und']) && is_array($node['field_addon_resources']['und'])) ? $node['field_addon_resources']['und'] : array();
    $addon_resources_config_markup = "";
    foreach($addon_resources as $resource_link_array){
      $addon_resources_config_markup .= '<li>'.l(t($resource_link_array['title']), $resource_link_array['url'], array('attributes' => array('class' => array('config-link')))).'</li>';
    }
    $import_code = (isset($node['field_install_script']['und']) && is_array($node['field_install_script']['und'])) ? $node['field_install_script']['und'][0]['value'] : null;
    switch ($addon_type_id){
      case 1:
        //module
     //   dsm("module");
        $return_msg = sauce_download_project($package_url);
      //  dsm($return_msg);
        $module_list[]=$addon_id;/*
        if(empty($import_code)){
        $import_code = "drush dl $addon_id\r\n";
        $import_code .= "drush en $addon_id -y";
        }
        $import_code_array = explode("\r\n",$import_code);
        dsm($import_code_array);
        foreach($import_code_array as $script_command){
        // drush dl $addon_id
        dsm("*$script_command*");
        $output = shell_exec($script_command);
        // $script_command1 = 'drush dl danland';
        //  $output = shell_exec($script_command1);
        dsm($output);
        }*/
        if(!empty($addon_resources_config_markup)){
        $sauce_config_markup .= '<fieldset class="form-wrapper"><legend><span class="fieldset-legend">'.$addon_title.'</span></legend><div class="fieldset-wrapper">
            <ul>'.$addon_resources_config_markup.'</ul>
            </div></fieldset>';

        }
        break;
      case 2:
        //theme
     //   dsm("theme");
        $return_msg = sauce_download_project($package_url);
      //  dsm($return_msg);
        $theme_list[]=$addon_id;
        /*
         if(empty($import_code)){
        $import_code = "drush dl $addon_id\r\n";
        $import_code .= "drush en $addon_id -y";
        }
        $import_code_array = explode("\r\n",$import_code);
        dsm($import_code_array);
        foreach($import_code_array as $script_command){
        // drush dl $addon_id
        dsm("*$script_command*");
        $output = shell_exec($script_command);
        // $script_command1 = 'drush dl danland';
        //  $output = shell_exec($script_command1);
        dsm($output);
        }*/
        $sauce_config_markup .= '<fieldset class="form-wrapper"><legend><span class="fieldset-legend">'.$addon_title.'</span></legend><div class="fieldset-wrapper">
            <ul>
            <li>'.l(t('Blocks'), 'admin/structure/block/list/'.$addon_id, array('attributes' => array('class' => array('config-link')))).'</li>
                <li>'.l(t('Theme Settings'), 'admin/appearance/settings/'.$addon_id, array('attributes' => array('class' => array('config-link')))).'</li>
                    <li>'.l(t('Set default'), 'admin/appearance/default', array(
                        'query' => array('token' => drupal_get_token('system-theme-operation-link'),
                            'theme' => $addon_id),
                        'attributes' => array('class' => array('config-link'),
                        ))).'</li>'.$addon_resources_config_markup.'
                            </ul>
                            </div></fieldset>';


        break;
      case 3:
        //Library
       // dsm("Library ".$package_url);
        $return_msg = sauce_download_project($package_url, TRUE);
        //dsm($return_msg);
        /*
         $import_code_array = explode("\r\n",$import_code);
        dsm($import_code_array);
        foreach($import_code_array as $script_command){
        // drush dl $addon_id
        dsm("*$script_command*");
        $output = shell_exec('whoami');
        $output .= shell_exec($script_command);
        // $script_command1 = 'whoami';
        //$output = shell_exec($script_command1);


        }
        dsm($output);
        */
        if(!empty($addon_resources_config_markup)){
        $sauce_config_markup .= '<fieldset class="form-wrapper"><legend><span class="fieldset-legend">'.$addon_title.'</span></legend><div class="fieldset-wrapper">
            <ul>
            <ul>'.$addon_resources_config_markup.'</ul>
            </ul>
            </div></fieldset>';
        }

        break;
      case 4:
        //Drulenium
      //  dsm("Drulenium ");
        module_load_include('inc', 'ctools', 'includes/export');
        $item = ctools_export_crud_import('drulenium_preset', $import_code);
       // dsm($item);
        ctools_export_crud_save('drulenium_preset', $item);
        $cid = $item->name;
      //  dsm($cid);
        $sauce_config_markup .= '<fieldset class="form-wrapper"><legend><span class="fieldset-legend">'.$addon_title.'</span></legend><div class="fieldset-wrapper">
            <ul>
            <li>'.l(t('Configure'), 'admin/structure/drulenium/presets', array('attributes' => array('class' => array('config-link')))).'</li>
<li>'.l(t('Run'), 'drulenium/tests/list', array('attributes' => array('class' => array('config-link')))).'</li>'.$addon_resources_config_markup.'
                
                </ul>
                </div></fieldset>';
        break;
        case 5:
          //dynamic_fieldable_content
          module_load_include('inc', 'ctools', 'includes/export');
          $item = ctools_export_crud_import('dynamic_fieldable_content', $import_code);
          ctools_export_crud_save('dynamic_fieldable_content', $item);
          $cid = $item->name;
          $sauce_config_markup .= '<fieldset class="form-wrapper"><legend><span class="fieldset-legend">'.$addon_title.'</span></legend><div class="fieldset-wrapper">
            <ul>
            <li>'.l(t('Configure'), 'admin/structure/dynamic-content/list/'.$cid.'/edit', array('attributes' => array('class' => array('config-link')))).'</li>'.$addon_resources_config_markup.'
        
                </ul>
                </div></fieldset>';
          break;
          case 17:
            //View
            //  dsm("Drulenium ");
            module_load_include('inc', 'views', 'includes/admin');
            $views_form_state['values']['view'] = $import_code;
            $views_form_state['values']['name'] = $addon_id;
            $views_form_state['values']['name_override'] = 1;
            $views_form_state['values']['bypass_validation'] = 1;
            views_ui_import_validate($form, $views_form_state);
            views_ui_cache_set($views_form_state['view']);
            $cid = $views_form_state['view']->name;
          /*  module_load_include('inc', 'ctools', 'includes/export');
            $item = ctools_export_crud_import('view', $import_code);
            // dsm($item);
            ctools_export_crud_save('view', $item);
            $cid = $item->name;
            //  dsm($cid);
             
             */
            $sauce_config_markup .= '<fieldset class="form-wrapper"><legend><span class="fieldset-legend">'.$addon_title.'</span></legend><div class="fieldset-wrapper">
            <ul>
            <li>'.l(t('Edit & Save View'), 'admin/structure/views/view/'.$cid.'/edit', array('attributes' => array('class' => array('config-link')))).'</li>'.$addon_resources_config_markup.'
        
                </ul>
                </div></fieldset>';
            break;
        
        default:
          // dsm("default");
          break;
    }
  }
  if(!empty($module_list)){
    module_enable($module_list, TRUE);
    drupal_flush_all_caches();
  }
  if(!empty($theme_list)){
    theme_enable($theme_list, TRUE);
  }
  //get addon short id and if install script is empty, do drush
  //prepare configuration markup
  
  if(empty($sauce_config_markup)){
    $sauce_config_markup = 'No configuration steps found.';
  }
  $form_state['values']['sauce_config_markup_hidden'] = $sauce_config_markup;
}

/**
 * Handles the submission of the final stage
 *
 * Sends an email to the user confirming their entry
 *
 * @param type $form
 * @param type $form_state
 */
function sauce_configure_submit($form, &$form_state) {

  $multstep_values = $form_state['multistep_values'];

  $module = 'sauce';
  $key = 'sauce_complete';

  $to = $multstep_values['personal_details']['email'] . '; ' . variable_get('site_mail', 'admin@example.com');
  $from = variable_get('site_mail', 'admin@example.com');

  $params = array(
      'body' => 'Thank you for filling in our survey. You have now been entered into our prize draw.',
      'subject' => 'Thank you for filling in our survey, ' . $multstep_values['personal_details']['name'],
  );

  $language = language_default();
  $send = TRUE;
  $result = drupal_mail($module, $key, $to, $language, $params, $from, $send);
  if ($result['result'] == TRUE) {
    drupal_set_message(t('Your message has been sent.'));
  }
  else {
    drupal_set_message(t('There was a problem sending your message and it was not sent.'), 'error');
  }

}

/**
 * Returns what to show on the completion page.
 *
 * @return type
 */
function sauce_complete() {

  return 'Thank you for completing our survey. You have been sent an email confirming you\'ve been entered into our prize draw';

}